//---------------------------------------------------------------------------
#ifndef DefinitionsH
#define DefinitionsH
//---------------------------------------------------------------------------
#include <string>
#include <vector>
#include <gimite/temp_array.h>
#include <boost/date_time/posix_time/posix_time.hpp>
#include <boost/shared_ptr.hpp>
//---------------------------------------------------------------------------
typedef unsigned char uchar;
//---------------------------------------------------------------------------
enum TSearchMode{//[h
  smNormal,//ʏ팟
  smWord,//[h
  smRegex,//K\
};
//---------------------------------------------------------------------------
//obt@̑傫w\basic_filebuf
template<class T, class Traits= std::char_traits<T> >
class basic_customfilebuf: public std::basic_filebuf<T, Traits>
{
	gimite::temp_array<char> buf_;

public:
	explicit basic_customfilebuf(std::size_t bufsize): buf_(bufsize)
		{ setbuf(buf_.get(), bufsize); }

};

//obt@̑傫w\basic_ifstream
template<class T, class Traits= std::char_traits<T> >
class basic_customifstream: public std::basic_istream<T, Traits>
{
	typedef std::basic_istream<T, Traits> base_t;
	typedef basic_customfilebuf<T, Traits> filebuf_t;

	filebuf_t buf_;

public:
	basic_customifstream(std::size_t bufsize)
			: base_t(0), buf_(bufsize){
		base_t::rdbuf(&buf_);
	}
	basic_customifstream(std::size_t bufsize, const char* s,
				std::ios_base::openmode mode= std::ios_base::in)
			: base_t(0), buf_(bufsize){
		base_t::rdbuf(&buf_);
		if (!buf_.open(s, mode|std::ios_base::in))
			setstate(std::ios_base::failbit);
	}
	virtual ~basic_customifstream(){ base_t::rdbuf(0); }
	void open(const char* s, std::ios_base::openmode= std::ios_base::in){
		if (!buf_.open(s, mode|std::ios_base::in))
			setstate(std::ios_base::failbit);
	}
	void close()
		{ if (!buf_.close()) setstate(std::ios_base::failbit); }
	filebuf_t* rdbuf()const
		{ return const_cast<filebuf_t*>(&buf_); }

};

typedef basic_customfilebuf<char> customfilebuf;
typedef basic_customifstream<char> customifstream;
//---------------------------------------------------------------------------
typedef boost::posix_time::ptime TPosixTime;
typedef boost::shared_ptr<TPosixTime> TPosixTimePtr;
typedef boost::posix_time::time_duration TTimeDuration;
typedef std::vector<std::string> TStringVector;
//---------------------------------------------------------------------------
std::string IncludingDir(const std::vector<std::string>& paths);
	//St@C܂ރfBNg
std::string RelativePath(const std::string& path,
		const std::string& pathBase);
	//pathBaseƂpath̑΃pX߂
	//ipathBasewtH_pathꍇ̂݁j
TStringVector Tokenize(const std::string& s);
  //Xy[Xŕi" "ł̃NI[gɑΉj
//---------------------------------------------------------------------------
TPosixTime SystemTimeToPTime(const SYSTEMTIME& stime);
	//SYSTEMTIMEptimeɕϊ
std::string PTimeToJapanese(const TPosixTime& time);
	//ptime"yyyyNmd h:nn:ss"\Lɕϊ
TPosixTime GetFileLastWriteTime(const std::string& path);
  //t@C̍ŏIXV擾B
std::istream& operator>>(std::istream& is, TPosixTime& time);
std::ostream& operator<<(std::ostream& os, const TPosixTime& time);
std::istream& operator>>(std::istream& is, TTimeDuration& time);
std::ostream& operator<<(std::ostream& os, const TTimeDuration& time);
//---------------------------------------------------------------------------
#endif
