//---------------------------------------------------------------------------
#include "Precompiled.h"
#pragma hdrstop

#include <algorithm>
#include <iterator>
#include <set>
#include <boost/cast.hpp>
#include <boost/bind.hpp>
#include <gimite/string_algo.h>
#include "Win32Common.h"
#include "VCLCommon.h"
#include "PlaceList.h"
#include "Backup.h"
#include "FileSet.h"
using namespace std;
using namespace boost;
using namespace gimite;
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
void TFileSet::SetDir(const std::string& pathDir,
	const TStringVector& ssFilter, bool bSubDir)//ΏۃtH_w(*1)
{
  try{
    AddFilesInDir(pathDir, ssFilter);
    if (bSubDir){
      ForEachSubDir(pathDir,
          bind(&TFileSet::AddFilesInDir, this, _1, ssFilter));
    }
  }catch (...){
    paths_.clear();
    throw;
  }
}

//---------------------------------------------------------------------------
TSearchResult TFileSet::Search(TAbstractSearchedPattern* pattern,
    TAbstractPlaceList* listPlace)
  //patterngČʂlistPlaceɒǉ
{
	GIMITE_MAPROFILED_OP("TFileSet::Search");
	assert(pattern);
	bool bMultiByte= MultiByte();
  if (paths_.empty()) return srNoFiles;
	for (size_t i= 0; i<paths_.size(); ++i){
  	ReportProcess(ptSearch, paths_[i], i, paths_.size());
    bool bHit= false;
    TPosixTimePtr time;
    if (bCheckTime_){
      time= TPosixTimePtr(new TPosixTime(GetFileLastWriteTime(paths_[i])));
    }
    if (bMultiByte){
	    bHit= SearchFile(paths_[i],
      		polymorphic_downcast<TSearchedPattern<wchar_t>*>(pattern),
          polymorphic_downcast<TPlaceList<wchar_t>*>(listPlace));
    }else{
	    bHit= SearchFile(paths_[i],
      		polymorphic_downcast<TSearchedPattern<char>*>(pattern),
          polymorphic_downcast<TPlaceList<char>*>(listPlace));
    }
    if (bCheckTime_ && bHit){
      timesFile_[paths_[i]]= time;
    }
  }
  return srOk;
}
//---------------------------------------------------------------------------
TReplaceResult TFileSet::Replace(TAbstractReplacingPattern* pattern,
    TAbstractPlaceList* listPlace, bool bBackup)
  //patternglistPlacȇIꂽʒuu
{
	assert(pattern);
	bool bMultiByte= MultiByte();

  //Ώۃt@C
  set<string> pathsT;
  for (size_t i= 0; i<listPlace->PlaceCount(); ++i){
  	if (listPlace->Place(i)->Selected())
    	pathsT.insert(listPlace->Place(i)->Path());
  }

	//obNAbv
  if (bBackup){
		ReportProcess(ptBackup, "", 0, 0);
		backup_->Backup(TStringVector(pathsT.begin(), pathsT.end()));
	}

  //u
	int nFile= 0;
	for (size_t i= 0; i<paths_.size(); ++i){
			//pathsT[vȂ̂͌Ɠɂ邽
		if (!pathsT.count(paths_[i])) continue;
		ReportProcess(ptReplace, paths_[i], nFile, pathsT.size());
		if (bMultiByte){
	    ReplaceFile(paths_[i],
      		polymorphic_downcast<TReplacingPattern<wchar_t>*>(pattern),
          polymorphic_downcast<TPlaceList<wchar_t>*>(listPlace));
    }else{
	    ReplaceFile(paths_[i],
      		polymorphic_downcast<TReplacingPattern<char>*>(pattern),
          polymorphic_downcast<TPlaceList<char>*>(listPlace));
    }
    ++nFile;
  }
  
  return rrOk;
}

//---------------------------------------------------------------------------
TFile<char>* TFileSet::NewFile(const std::string& path, char*)const
  //pathŎw肳ꂽVOoCg̃t@CIuWFNg
{
	TFile<char>* file= new TFile<char>;
  file->SetPath(path);
  file->SetCharCode(ccode_);
  	//R[hASCIIłȂ΂assertion fail
  return file;
}

//---------------------------------------------------------------------------
TFile<wchar_t>* TFileSet::NewFile(const std::string& path, wchar_t*)const
  //pathŎw肳ꂽ}`oCg̃t@CIuWFNg
{
	TFile<wchar_t>* file= new TFile<wchar_t>;
  file->SetPath(path);
  file->SetCharCode(ccode_);
  return file;
}

//---------------------------------------------------------------------------
bool TFileSet::AddFilesInDir(const std::string& pathDir,
  const TStringVector& ssFilter)//pathDir̃t@CΏۂɒǉ
{
  ReportProcess(ptEnumFiles, pathDir, 0, paths_.size());
  TPathSet set_path;
  for (size_t i= 0; i<ssFilter.size(); ++i)
		ForEachFileInDir(pathDir, ssFilter[i],
    	bind(&TFileSet::AddFileToSet, this, _1, &set_path));
  copy(set_path.begin(), set_path.end(), back_inserter(paths_));
  return true;
}

//---------------------------------------------------------------------------
bool TFileSet::IsFileChanged(const std::string& path)
  //t@CɕύXꂽ
{
  return timesFile_[path].get() &&
    GetFileLastWriteTime(path) != *timesFile_[path];
}

//---------------------------------------------------------------------------
void TFileSet::ReportProcess(TProcessType type, const std::string& path,
	  int nCurrent, int ctAll)
 	//ߒ
{
  if (!onReportProcess_.empty())
  	onReportProcess_(type, path, nCurrent, ctAll);
}

//---------------------------------------------------------------------------
TDecision TFileSet::QueryFileError
		(const std::string& path, TFileOperationResult r)
	//t@CG[̏uu
{
	if (!onFileError_.empty()) return onFileError_(path, r);
	else return dcSkip;
}

//---------------------------------------------------------------------------

