//---------------------------------------------------------------------------
#ifndef MainFormH
#define MainFormH
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ComCtrls.hpp>
#include <Menus.hpp>
#include <Dialogs.hpp>
#include <AppEvnts.hpp>
#include <ActnList.hpp>
#include <StdActns.hpp>
#include <ExtCtrls.hpp>
#include <vector>
#include <string>
#include "DevasApp.h"
#include "Serializer.h"
//---------------------------------------------------------------------------
enum TViewState{//r[̏
	vsNone,//
  vsReady,//
  vsSearching,//
  vsReplacable,//ς݁iuj
  vsUnreplacable,//ς݁iusj
  vsReplacing,//u
};

//---------------------------------------------------------------------------
class TfrmMain : public TForm
{
__published:	// IDE Ǘ̃R|[lg
  TMainMenu *mnuMain;
	TMenuItem *mniTool;
	TPopupMenu *pmnPathRef;
	TMenuItem *mniDirRef;
  TMenuItem *mniFileRef;
  TOpenDialog *dlgOpen;
	TMenuItem *mniOption;
  TMenuItem *mniHelp;
  TMenuItem *mniHelpC;
  TMenuItem *mniAbout;
	TLabel *lblPath;
	TLabel *lblFilter;
	TLabel *lblSearched;
	TComboBox *cmbPath;
	TComboBox *cmbFilter;
	TButton *btnSearch;
	TButton *btnPathRef;
  TCheckBox *chkSubDir;
	TComboBox *cmbMode;
	TComboBox *cmbSearched;
	TButton *btnOption;
	TApplicationEvents *evtApp;
	TMenuItem *mniCopyResult;
  TTimer *tmrSearch;
  TStatusBar *stbMain;
  TButton *btnSearchedEdit;
	void __fastcall FormCreate(TObject *Sender);
	void __fastcall btnSearchClick(TObject *Sender);
	void __fastcall FormShow(TObject *Sender);
	void __fastcall ctlSearchChange(TObject *Sender);
	void __fastcall mniOptionClick(TObject *Sender);
	void __fastcall btnPathRefClick(TObject *Sender);
	void __fastcall mniDirRefClick(TObject *Sender);
	void __fastcall mniFileRefClick(TObject *Sender);
	void __fastcall mniHelpCClick(TObject *Sender);
	void __fastcall mniAboutClick(TObject *Sender);
	void __fastcall FormCloseQuery(TObject *Sender, bool &CanClose);
	void __fastcall evtAppException(TObject *Sender, Exception *E);
	void __fastcall mniCopyResultClick(TObject *Sender);
  void __fastcall tmrSearchTimer(TObject *Sender);
  void __fastcall btnSearchedEditClick(TObject *Sender);
private:	// [U[錾
	typedef std::vector<std::string> TStringVector;
	typedef TPosixTime TPosixTime;

  static const int ctComboBoxHistory_= 50;//R{{bNX̓͗
  static const int lenInitialSearch_= 1024;
    //NɃNbv{[h\t镶̍őlB

  TViewState state_;//r[̏
  std::auto_ptr<TDevasApp> app_;//AvP[V(UN)
  std::auto_ptr<TSerializer> serial_;//VACU(UN)
  AnsiString pathSaved_;//Avf[^̕ۑ
	std::string pathBaseDir_;
		//t@C\̊ƂȂtH_̃pX
  std::set<TFileOperationResult> resultsSkip_;
    //̃G[Nt@C͑SăXLbv

	void SetGUITexts();//GUĨeLXgݒ
	void ReadCommandLine();//R}hCǂݍ
  static TStringVector TokenizePath(const AnsiString& asPaths);
  	//擪̃pXNI[gĂΕA
    //łȂΑŜ1̃pXƂ݂Ȃ
  static TStringVector TokenizeFilter(const AnsiString& as);
  	//tB^𕪉
  static AnsiString DetokenizePath(const TStringVector& paths);
  	//pX̔zNI[gČq
  void SetBaseDir(const TStringVector paths);//tH_ݒ
  void OnPlaceAdd(TAbstractPlace* place);
  	//ʒuǉꂽ
  void OnReportProcess(TProcessType type, const std::string& path,
	  	int nCurrent, int ctAll);
		//ߒ̕
	TDecision OnFileError(const std::string& path, TFileOperationResult r);
		//t@CG[[Uɐu
	bool OnQueryDeleteBackup(const std::vector<TBackupUnit*>& punits);
		//obNAbvu
	bool OnBackupExceedingUnit(DWORD size);
		//P̂ŏ𒴂TCỸobNAbvPʂobNAbv邩
	void PlaceForms();//tH[̔zu
	bool CheckPaths(const TStringVector& paths);
		//ΏۃpX̐`FbN

	void __fastcall WMDropFiles(TWMDropFiles &msg);

public:		// [U[錾
	__fastcall TfrmMain(TComponent* Owner);
	void __fastcall WndProc(TMessage &Message);
	void Initialize();//r[̏
	void Settle();//r[̌n
	std::string RelativePath(const std::string path);
		//pathtH_̑΃pX߂
	TViewState State()const{return state_;}//r[̏
	void SetState(TViewState state);//r[̏Ԃ̕ύX
	TDevasApp* DevasApp(){return app_.get();}//AvP[V
	void ComboBoxAddToHistory(TComboBox* cmb);
		//R{{bNXcmbTextɒǉ
	void ClearSkips();
		///úuSăXLbvv̏ԂNA
  void OutputMessage(const std::string& s);
    //Xe[^Xo[ɃbZ[W\
	void OnOptionChanged();//IvVXVꂽ

	BEGIN_MESSAGE_MAP
		MESSAGE_HANDLER(WM_DROPFILES, TWMDropFiles, WMDropFiles)
	END_MESSAGE_MAP(TForm)

};

//---------------------------------------------------------------------------
extern PACKAGE TfrmMain *frmMain;
//---------------------------------------------------------------------------
#endif
