//---------------------------------------------------------------------------
#ifndef ReplacingPatternH
#define ReplacingPatternH
//---------------------------------------------------------------------------
#include <string>
#include "Definitions.h"
#include "StrProcess.h"
#include "PlaceList.h"
//---------------------------------------------------------------------------
struct TReplaceInfo//up^[邽߂̏
{
	bool bMultiByte_;//}`oCg
  std::string sReplacing_;//u
  TSearchMode mode_;//[h
  bool bEscape_;//GXP[vg
};

//---------------------------------------------------------------------------
//up^[̋ʊNX
class TAbstractReplacingPattern
{
public:
	virtual ~TAbstractReplacingPattern(){}
	static TAbstractReplacingPattern*
  		NewReplacingPattern(const TReplaceInfo& info);
    //w̏𖞂up^[

};

//---------------------------------------------------------------------------
//up^[
template <class TChar>
class TReplacingPattern: public TAbstractReplacingPattern
{
public:
	typedef std::basic_string<TChar> TString;

  bool Replace(TString& text, TPlaceList<TChar>* listPlace,
	 		const std::string& path);
  	//listPlacepath̑IꂽʒuSĒu(*1)
  virtual TString ReplacingTstr(const TPlaceList<TChar>* listPlace,
  		int nPlace)= 0;
  	//listPlacenPlaceԖڂ̒u̕

};

//*1	ûꍇtrueԂ
//---------------------------------------------------------------------------
//ʌ̒up^[
template <class TChar>
class TNormalReplacingPattern: public TReplacingPattern<TChar>
{
public:
	typedef TReplacingPattern<TChar>::TString TString;

  explicit TNormalReplacingPattern(const TString& tsReplacing)
  	: tsReplacing_(tsReplacing){}
  virtual TString ReplacingTstr(const TPlaceList<TChar>* listPlace,
  		int nPlace){return tsReplacing_;}
  	//listPlacenPlaceԖڂ̒u̕

private:
	TString tsReplacing_;//u

};

//---------------------------------------------------------------------------
//K\̒up^[
template <class TChar>
class TRegexReplacingPattern: public TReplacingPattern<TChar>
{
public:
	typedef TReplacingPattern<TChar>::TString TString;

  explicit TRegexReplacingPattern(const TString& tsReplacing)
  	: tsReplacing_(tsReplacing){}
  virtual TString ReplacingTstr(const TPlaceList<TChar>* listPlace,
  		int nPlace);
  	//listPlacenPlaceԖڂ̒u̕

private:
	TString tsReplacing_;//u

};

//---------------------------------------------------------------------------
template <class T>
bool TReplacingPattern<T>::Replace(TString& text,
		TPlaceList<T>* listPlace, const std::string& path)
  //listPlacepath̑IꂽʒuSĒu
{
	typedef TString::size_type TSize;
  bool bReplaced= false;
  TSize pos= 0;
  int nLine= 0;
  TSize posLineBg= 0;
  TString textR;
  TSize len= text.length();
  textR.reserve(len);
	for (int i= 0; i<listPlace->PlaceCount(); ++i){
		TPlace<T>* place= listPlace->Place(i);
		if (place->Path()==path){
			if (place->Selected()){
				//??̕ӃoOv`FbN
				while (place->LineNumber()>nLine){//uʒu̍sT
					posLineBg= text.find('\n', posLineBg);
					if (posLineBg==TString::npos) break;
					++posLineBg; ++nLine;
				}
				if (posLineBg==TString::npos) posLineBg= len;
				TSize posT= std::min(posLineBg+place->Position(), len);
					//t@C擪̈ʒu
				assert(posT>=pos);
				textR+= text.substr(pos, posT-pos);
				textR+= ReplacingTstr(listPlace, i);
				pos= std::min(posT+place->Length(), len);
        bReplaced= true;
			}
    }
  }
  textR+= text.substr(pos);
  text= textR;
  return bReplaced;
}

//---------------------------------------------------------------------------
template <class T>
TRegexReplacingPattern<T>::TString TRegexReplacingPattern<T>
		::ReplacingTstr(const TPlaceList<T>* listPlace, int nPlace)
 	//listPlacenPlaceԖڂ̒u̕
{
	enum{rsNormal, rsOne, rsLong} rstate= rsNormal;
  bool bUpper= false;
	const TPlace<T>* place= listPlace->Place(nPlace);
  TString tsR;
  for (TString::size_type pos= 0; pos<tsReplacing_.length(); ++pos){
    TString ts;
    if (tsReplacing_[pos]=='\\'){
      ++pos;
      if (pos>=tsReplacing_.length()) break;
      T tc= tsReplacing_[pos];
      if (isdigit(tc)){
        ts+= place->RefTstr(char(tc)-'0');
      }else if (T(uchar(tc))!=tc){//2oCg
      	ts+= tc;
      }else{
        const char* cs1= "\n\t\a\f\r\v";
        const char* cs2= "ntafrv";
      	const char* p= std::strchr(cs2, tc);
        if (p){
        	ts+= T(uchar(cs1[p-cs2]));//GXP[vɑΉ
        }else{
          switch (char(tc)){
            case 'l': rstate= rsOne; bUpper= false; break;
            case 'L': rstate= rsLong; bUpper= false; break;
            case 'u': rstate= rsOne; bUpper= true; break;
            case 'U': rstate= rsLong; bUpper= true; break;
            case 'E': rstate= rsNormal; break;
            default: ts+= tc; break;
          }
        }
      }
    }else{
      ts+= tsReplacing_[pos];
    }
    switch (rstate){
      case rsNormal:{
      	tsR+= ts;
        break;
      }case rsOne:{
        if (!ts.empty()){
	        if (bUpper) tsR+= toupper(ts[0]);
          else tsR+= tolower(ts[0]);
          tsR+= ts.substr(1);
          rstate= rsNormal;
        }
        break;
      }case rsLong:{
        for (TString::size_type i= 0; i<ts.length(); ++i){
          if (bUpper) tsR+= toupper(ts[i]);
          else tsR+= tolower(ts[i]);
        }
        break;
      }
    }
  }
  return tsR;
}

//---------------------------------------------------------------------------
#endif
