#ifndef GIMITE_new_sharedH
#define GIMITE_new_sharedH
//---------------------------------------------------------------------------
#include <boost/shared_ptr.hpp>
#include <boost/ref.hpp>
//---------------------------------------------------------------------------
namespace gimite{
//---------------------------------------------------------------------------
//boost::reference_wrapperŃbvĂ΁A͂B

template <class T>
const T& unref(const T& v){ return v; }

template <class T>
T& unref(const boost::reference_wrapper<T>& v){ return v; }
//---------------------------------------------------------------------------
//boost::shared_ptr<T>(new T(...)) ̏ȗ`A new_shared<T>(...) `B

template <class T>
inline boost::shared_ptr<T> new_shared(){
  return boost::shared_ptr<T>(new T);
}

template <class T, class T1>
inline boost::shared_ptr<T> new_shared(
  const T1& a1){
    return boost::shared_ptr<T>(new T(
      unref(a1)
    ));
}

template <class T, class T1, class T2>
inline boost::shared_ptr<T> new_shared(
  const T1& a1, const T2& a2){
    return boost::shared_ptr<T>(new T(
      unref(a1), unref(a2)
    ));
}

template <class T, class T1, class T2, class T3>
inline boost::shared_ptr<T> new_shared(
  const T1& a1, const T2& a2, const T3& a3){
    return boost::shared_ptr<T>(new T(
      unref(a1), unref(a2), unref(a3)
    ));
}

template <class T, class T1, class T2, class T3, class T4>
inline boost::shared_ptr<T> new_shared(
  const T1& a1, const T2& a2, const T3& a3, const T4& a4){
    return boost::shared_ptr<T>(new T(
      unref(a1), unref(a2), unref(a3), unref(a4)
    ));
}

template <class T, class T1, class T2, class T3, class T4, class T5>
inline boost::shared_ptr<T> new_shared(
  const T1& a1, const T2& a2, const T3& a3, const T4& a4, const T5& a5){
    return boost::shared_ptr<T>(new T(
      unref(a1), unref(a2), unref(a3), unref(a4), unref(a5)
    ));
}

template <class T, class T1, class T2, class T3, class T4, class T5, class T6>
inline boost::shared_ptr<T> new_shared(
  const T1& a1, const T2& a2, const T3& a3, const T4& a4, const T5& a5, const T6& a6){
    return boost::shared_ptr<T>(new T(
      unref(a1), unref(a2), unref(a3), unref(a4), unref(a5), unref(a6)
    ));
}

template <class T, class T1, class T2, class T3, class T4, class T5, class T6, class T7>
inline boost::shared_ptr<T> new_shared(
  const T1& a1, const T2& a2, const T3& a3, const T4& a4, const T5& a5, const T6& a6, const T7& a7){
    return boost::shared_ptr<T>(new T(
      unref(a1), unref(a2), unref(a3), unref(a4), unref(a5), unref(a6), unref(a7)
    ));
}

template <class T, class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8>
inline boost::shared_ptr<T> new_shared(
  const T1& a1, const T2& a2, const T3& a3, const T4& a4, const T5& a5, const T6& a6, const T7& a7, const T8& a8){
    return boost::shared_ptr<T>(new T(
      unref(a1), unref(a2), unref(a3), unref(a4), unref(a5), unref(a6), unref(a7), unref(a8)
    ));
}

template <class T, class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9>
inline boost::shared_ptr<T> new_shared(
  const T1& a1, const T2& a2, const T3& a3, const T4& a4, const T5& a5, const T6& a6, const T7& a7, const T8& a8, const T9& a9){
    return boost::shared_ptr<T>(new T(
      unref(a1), unref(a2), unref(a3), unref(a4), unref(a5), unref(a6), unref(a7), unref(a8), unref(a9)
    ));
}

template <class T, class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10>
inline boost::shared_ptr<T> new_shared(
  const T1& a1, const T2& a2, const T3& a3, const T4& a4, const T5& a5, const T6& a6, const T7& a7, const T8& a8, const T9& a9, const T10& a10){
    return boost::shared_ptr<T>(new T(
      unref(a1), unref(a2), unref(a3), unref(a4), unref(a5), unref(a6), unref(a7), unref(a8), unref(a9), unref(a10)
    ));
}

template <class T, class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11>
inline boost::shared_ptr<T> new_shared(
  const T1& a1, const T2& a2, const T3& a3, const T4& a4, const T5& a5, const T6& a6, const T7& a7, const T8& a8, const T9& a9, const T10& a10, const T11& a11){
    return boost::shared_ptr<T>(new T(
      unref(a1), unref(a2), unref(a3), unref(a4), unref(a5), unref(a6), unref(a7), unref(a8), unref(a9), unref(a10), unref(a11)
    ));
}

template <class T, class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12>
inline boost::shared_ptr<T> new_shared(
  const T1& a1, const T2& a2, const T3& a3, const T4& a4, const T5& a5, const T6& a6, const T7& a7, const T8& a8, const T9& a9, const T10& a10, const T11& a11, const T12& a12){
    return boost::shared_ptr<T>(new T(
      unref(a1), unref(a2), unref(a3), unref(a4), unref(a5), unref(a6), unref(a7), unref(a8), unref(a9), unref(a10), unref(a11), unref(a12)
    ));
}

template <class T, class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13>
inline boost::shared_ptr<T> new_shared(
  const T1& a1, const T2& a2, const T3& a3, const T4& a4, const T5& a5, const T6& a6, const T7& a7, const T8& a8, const T9& a9, const T10& a10, const T11& a11, const T12& a12, const T13& a13){
    return boost::shared_ptr<T>(new T(
      unref(a1), unref(a2), unref(a3), unref(a4), unref(a5), unref(a6), unref(a7), unref(a8), unref(a9), unref(a10), unref(a11), unref(a12), unref(a13)
    ));
}

template <class T, class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13, class T14>
inline boost::shared_ptr<T> new_shared(
  const T1& a1, const T2& a2, const T3& a3, const T4& a4, const T5& a5, const T6& a6, const T7& a7, const T8& a8, const T9& a9, const T10& a10, const T11& a11, const T12& a12, const T13& a13, const T14& a14){
    return boost::shared_ptr<T>(new T(
      unref(a1), unref(a2), unref(a3), unref(a4), unref(a5), unref(a6), unref(a7), unref(a8), unref(a9), unref(a10), unref(a11), unref(a12), unref(a13), unref(a14)
    ));
}

template <class T, class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13, class T14, class T15>
inline boost::shared_ptr<T> new_shared(
  const T1& a1, const T2& a2, const T3& a3, const T4& a4, const T5& a5, const T6& a6, const T7& a7, const T8& a8, const T9& a9, const T10& a10, const T11& a11, const T12& a12, const T13& a13, const T14& a14, const T15& a15){
    return boost::shared_ptr<T>(new T(
      unref(a1), unref(a2), unref(a3), unref(a4), unref(a5), unref(a6), unref(a7), unref(a8), unref(a9), unref(a10), unref(a11), unref(a12), unref(a13), unref(a14), unref(a15)
    ));
}

template <class T, class T1, class T2, class T3, class T4, class T5, class T6, class T7, class T8, class T9, class T10, class T11, class T12, class T13, class T14, class T15, class T16>
inline boost::shared_ptr<T> new_shared(
  const T1& a1, const T2& a2, const T3& a3, const T4& a4, const T5& a5, const T6& a6, const T7& a7, const T8& a8, const T9& a9, const T10& a10, const T11& a11, const T12& a12, const T13& a13, const T14& a14, const T15& a15, const T16& a16){
    return boost::shared_ptr<T>(new T(
      unref(a1), unref(a2), unref(a3), unref(a4), unref(a5), unref(a6), unref(a7), unref(a8), unref(a9), unref(a10), unref(a11), unref(a12), unref(a13), unref(a14), unref(a15), unref(a16)
    ));
}
//---------------------------------------------------------------------------
}
//---------------------------------------------------------------------------
#endif
//---------------------------------------------------------------------------
