//---------------------------------------------------------------------------
/*
                    string_algo Ver.1.0  by Gimite

*/
//---------------------------------------------------------------------------
#ifndef GIMITE_string_algoH
#define GIMITE_string_algoH
//---------------------------------------------------------------------------
#include <string>
#include <sstream>
//---------------------------------------------------------------------------
namespace gimite{
//---------------------------------------------------------------------------
template <class T>
std::basic_string<T> str_replace_all_copy(
    const std::basic_string<T>& text,
    const std::basic_string<T>& old_str,
    const std::basic_string<T>& new_str)
{
  std::basic_string<T> result;
  typename std::basic_string<T>::size_type pos= 0, prev_pos= 0;
  while ((pos= text.find(old_str, pos)) != std::basic_string<T>::npos){
    result+= text.substr(prev_pos, pos-prev_pos);
    result+= new_str;
    pos= prev_pos= pos+old_str.length();
  }
  result+= text.substr(prev_pos);
  return result;
}

//---------------------------------------------------------------------------
template <class T>
std::string to_str(const T& v)
{
  std::ostringstream ss;
  ss << v;
  return ss.str();
}

//---------------------------------------------------------------------------
template <class T>
std::string join(const std::string& str, const T& cont)
{
  std::ostringstream ss;
  for (typename T::const_iterator it= cont.begin(); it!=cont.end(); ++it){
    if (it!=cont.begin()) ss << str;
    ss << *it;
  }
  return ss.str();
}

//---------------------------------------------------------------------------
}//namespace gimite
//---------------------------------------------------------------------------
#endif
